﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Excel = Microsoft.Office.Interop.Excel;
using System.Web.Services.Protocols;
using System.Xml;
using System.Xml.Linq;

namespace BlogList
{
    /// <summary>
    /// Interaction logic for BlogUserControl.xaml
    /// </summary>
    public partial class BlogUserControl : UserControl
    {
        List<Blog> myBlogs = new List<Blog>();
        public BlogUserControl()
        {
            InitializeComponent();
        }

        private void btnAddData_Click(object sender, RoutedEventArgs e)
        {
            SPListWS.Lists myListReadProxy = new SPListWS.Lists();
            myListReadProxy.Credentials =
            System.Net.CredentialCache.DefaultCredentials;
            myListReadProxy.Url = "http://anjie:8080/_vti_bin/Lists.asmx";
            try
            {
                XmlNode myListItems = myListReadProxy.GetListItems("Blog", null, null, null, null, null, null);
                XElement newRootElement = new XElement("BlogData");
                foreach (XmlNode outerNode in myListItems.ChildNodes)
                {
                    if (outerNode.NodeType.Equals(System.Xml.XmlNodeType.Element))
                    {
                        foreach (XmlNode node in outerNode.ChildNodes)
                        {
                            if (node.NodeType.Equals(System.Xml.XmlNodeType.Element))
                            {
                                XmlNode listFieldTitle = node.Attributes.GetNamedItem("ows_Title");
                                XmlNode listFieldContent = node.Attributes.GetNamedItem("ows_Content");
                                XmlNode listFieldAuthor = node.Attributes.GetNamedItem("ows_Writer");
                                Blog tempBlog = new Blog();
                                tempBlog.blogTitle = listFieldTitle.InnerText;
                                tempBlog.blogContent = listFieldContent.InnerText;
                                tempBlog.blogAuthor = listFieldAuthor.InnerText;
                                myBlogs.Add(tempBlog);
                                lstBxBlogs.Items.Add(tempBlog.blogTitle);
                            }
                        }
                    }
                }
            }
            catch (SoapException ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnUpdate_Click(object sender, RoutedEventArgs e)
        {
            Excel.Worksheet myProductWorksheet = Globals.ThisAddIn.Application.ActiveSheet as Excel.Worksheet;
            int index = 0;
            string strBlogUpdate = ((Excel.Range)myProductWorksheet.Cells[2, 1]).Value2.ToString();
            string strBlogContentUpdate = ((Excel.Range)myProductWorksheet.Cells[2, 2]).Value2.ToString();
            string strBlogAuthorUpdate = ((Excel.Range)myProductWorksheet.Cells[2, 3]).Value2.ToString();
            if (strBlogUpdate == "test")
            {
                index = 1;
            }
            else if (strBlogContentUpdate == "test")
            {
                index = 2;
            }
            else if (strBlogAuthorUpdate == "anjie")
            {
                index = 3;
            }
            SPListWS.Lists myListUpdateProxy = new SPListWS.Lists();
            myListUpdateProxy.Credentials = System.Net.CredentialCache.DefaultCredentials;
            myListUpdateProxy.Url = "http://anjie:8080/_vti_bin/Lists.asmx";
            System.Xml.XmlNode xmlListView = myListUpdateProxy.GetListAndView("Blog", "");
            string strListID = xmlListView.ChildNodes[0].Attributes["Name"].Value;
            string strViewID = xmlListView.ChildNodes[1].Attributes["Name"].Value;
            XmlDocument xmlDoc = new XmlDocument();
            XmlElement xmlBatchElement = xmlDoc.CreateElement("Batch");
            xmlBatchElement.SetAttribute("OnError", "Continue");
            xmlBatchElement.SetAttribute("ListVersion", "1");
            xmlBatchElement.SetAttribute("ViewName", strViewID);
            xmlBatchElement.InnerXml = "<Method ID='1' Cmd='Update'>" +
            "<Field Name='ID'>" + index + "</Field>" + "<Field Name='Title'>"
            + strBlogUpdate + "</Field><Field Name='Content'>" +
            strBlogContentUpdate + "</Field><Field Name='Writer'>" +
            strBlogAuthorUpdate + "</Field>" + "</Method>";
            try
            {
                XmlNode xmlReturn = myListUpdateProxy.UpdateListItems("Blog", xmlBatchElement);
                System.Windows.MessageBox.Show("Blog Information Added!");
            }
            catch (SoapException ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void lstBxBlogs_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            string strSelectedBlog = lstBxBlogs.SelectedItem.ToString();
            var blogs = from p in myBlogs
            .Where(p => p.blogTitle == strSelectedBlog)
                           select new { p.blogContent, p.blogAuthor };
            foreach (var d in blogs)
            {
                txtBxContent.Text = d.blogContent;
                txtBxAuthor.Text = d.blogAuthor;
            }
            Excel.Worksheet myBlogWorksheet = Globals.ThisAddIn.Application.ActiveSheet as Excel.Worksheet;
            ((Excel.Range)myBlogWorksheet.Cells[1, 1]).Value2 = "Title";
            ((Excel.Range)myBlogWorksheet.Cells[1, 2]).Value2 = "Content";
            ((Excel.Range)myBlogWorksheet.Cells[1, 3]).Value2 = "Writer";
            ((Excel.Range)myBlogWorksheet.Cells[2, 1]).Value2 = strSelectedBlog;
            ((Excel.Range)myBlogWorksheet.Cells[2, 2]).Value2 = txtBxContent.Text;
            ((Excel.Range)myBlogWorksheet.Cells[2, 3]).Value2 = txtBxAuthor.Text;
        }
    }
}
